##
## decrementCounter.py
## Check and Decrement the Counter for undoModelUpdates.py
##

import sys

import java.io.File as JavaFile

##
# Counter Location
##
def counterLocation():
    # return wasHome + "/properties/version/install.xd/backup.operationalpolicy"
    return wasHome + counterLoc

##
# Decrement Counter
##
def decrementCounter(theCount, counterFilePath):
    counterFile = open(counterFilePath, 'w')
    newCount = theCount - 1;
    newCountLine = "%s\n" % newCount
    counterFile.write(newCountLine)
    counterFile.close()

    print "Counter Decremented."
    return newCount

##
# Check and Decrement Counter
##
def checkAndDecrementCounter():
    if traceON: print "> checkAndDecrementCounter()"

    counterFilePath = "%s/counter" % counterLocation()
    counter = JavaFile(counterFilePath)
    newCount = -1

    if counter.exists():
        counterFile = open(counterFilePath, 'r')
        theCount = int(counterFile.readline())
        if traceON: print "Count is %s" % theCount
        counterFile.close()

        if theCount > 1:
            newCount = decrementCounter(theCount, counterFilePath)
            return [0, newCount]

        if theCount == 1:
            newCount = decrementCounter(theCount, counterFilePath)
            if counter.delete():
                print "Counter Deleted."
            else:
                print "FAILED to Delete Counter."
        else:
            return [0, 0]
    else:
        print "Counter Does NOT Exists."
        return [0, newCount]

    if traceON: print "< checkAndDecrementCounter()"

    return [1, newCount]

##
# Write Mark
##
def writeMark(mark, markerFilePath):
    markerFile = open(markerFilePath, 'w')
    markerLine = "%s\n" % mark
    markerFile.write(markerLine)
    markerFile.close()

##
# Set Marker File
##
def setMarker(mark):
    markerFilePath = "%s/execute" % counterLocation()
    marker = JavaFile(markerFilePath)

    if marker.exists():
        writeMark(mark, markerFilePath)
    else:
        if marker.createNewFile():
            writeMark(mark, markerFilePath)
            print "Marker Created."
        else:
            print "FAILED to Create Marker."

##--------------------
# Main
##--------------------

global traceON
global wasHome
global counterLoc

traceON = 0

if len(sys.argv) < 2:
    print "Two Parameters, <WAS_HOME> and <COUNTER_DIR>, are REQUIRED."
    print "Please retry with the parameters specified."
else:
    wasHome = sys.argv[0]
    counterLoc = sys.argv[1]

    if len(sys.argv) == 3:
        traceON = sys.argv[2]

    try:
        theCount = checkAndDecrementCounter()
        if theCount[0]:
            setMarker("true")
        else:
            print "Non-Applicable Installation:  Current Count = %s." % theCount[1]
            setMarker("false")
    except Exception, e:
        print "Exception: %s" % e
        print sys.exc_info()
        print "Exit Script."
