-- Scriptfile to create a Cloudscape database for the Postings batch sample application. This script
-- can be modified if needed to change the name of database or name of the Schema used. Default
-- database name is POSTINGS and default schema name is POSTINGSSCHEMA
-- The script will produce the Postings cloudscape database in the directory 
-- from which it is invoked.
-- Process This script in the ij command line processor.  
-- Example  
--    java -Djava.ext.dirs=C:/WebSPhere/AppServer/cloudscape/lib -Dij.protocol=jdbc:db2j: com.ibm.db2j.tools.ij CreatePostingsTablesCloudscape.ddl


CONNECT 'jdbc:db2j:POSTINGS;create=true';


CREATE SCHEMA POSTINGSSCHEMA;

CREATE TABLE "POSTINGSSCHEMA"."ACCOUNT"  (

		  "ACCOUNTID" VARCHAR(250) NOT NULL , 

		  "OVERDRAFTPROTECTION" DOUBLE , 

		  "OVERDRAFTUSED" DOUBLE , 

		  "BALANCE" DOUBLE )   

		 ; 



-- DDL Statements for primary key on Table "POSTINGSSCHEMA"."ACCOUNT"



ALTER TABLE "POSTINGSSCHEMA"."ACCOUNT" 

	ADD CONSTRAINT "PK_ACCOUNT" PRIMARY KEY

		("ACCOUNTID");







------------------------------------------------

-- DDL Statements for table "POSTINGSSCHEMA"."DATACREATIONBEAN"

------------------------------------------------

 

 CREATE TABLE "POSTINGSSCHEMA"."DATACREATIONBEAN"  (

		  "JOBID" VARCHAR(250) NOT NULL , 

		  "STEPID" VARCHAR(250) NOT NULL )   

		 ; 



-- DDL Statements for primary key on Table "POSTINGSSCHEMA"."DATACREATIONBEAN"



ALTER TABLE "POSTINGSSCHEMA"."DATACREATIONBEAN" 

	ADD CONSTRAINT "PK_DATACREATIONBE1" PRIMARY KEY

		("JOBID",

		 "STEPID");







------------------------------------------------

-- DDL Statements for table "POSTINGSSCHEMA"."POSTINGACCOUNTDATA"

------------------------------------------------

 

 CREATE TABLE "POSTINGSSCHEMA"."POSTINGACCOUNTDATA"  (

		  "JOBID" VARCHAR(250) NOT NULL , 

		  "STEPID" VARCHAR(250) NOT NULL )   

		 ; 



-- DDL Statements for primary key on Table "POSTINGSSCHEMA"."POSTINGACCOUNTDATA"



ALTER TABLE "POSTINGSSCHEMA"."POSTINGACCOUNTDATA" 

	ADD CONSTRAINT "PK_POSTINGACCOUNT2" PRIMARY KEY

		("JOBID",

		 "STEPID");


------------------------------------------------

-- DDL Statements for table "POSTINGSSCHEMA"."OVERDRAFTACCOUNTPOSTING"

------------------------------------------------

 

 CREATE TABLE "POSTINGSSCHEMA"."OVERDRAFTACCOUNTPOSTING"  (

		  "JOBID" VARCHAR(250) NOT NULL , 

		  "STEPID" VARCHAR(250) NOT NULL )   

		 ; 



-- DDL Statements for primary key on Table "POSTINGSSCHEMA"."OVERDRAFTACCOUNTPOSTING"



ALTER TABLE "POSTINGSSCHEMA"."OVERDRAFTACCOUNTPOSTING" 

	ADD CONSTRAINT "PK_ODPosting2" PRIMARY KEY

		("JOBID",

		 "STEPID");
                 
COMMIT WORK;


DISCONNECT;

