-- This script creates POSTINGS tables on an Informix instance.
-- The default name of the database is LREE, default schema name is
-- LREESCHEMA and default tablespace is rootdbs. All these defaults
-- can be replaced with different names if needed.
-- The following command can be issued from Informix command line processor.
-- To run this script, type at cmd-line in <informix_install>/bin 
-- dbaccess - CreatePostingsTablesInformix.sql


CONNECT TO "POSTINGS";


BEGIN WORK;

---------------------------------------
--DDL statements for SCHEMA: POSTINGSSCHEMA
---------------------------------------
CREATE SCHEMA AUTHORIZATION POSTINGSSCHEMA;


---------------------------------------------------
--DDL statements  for table: "POSTINGSSCHEMA.ACCOUNT"
---------------------------------------------------
CREATE TABLE  POSTINGSSCHEMA.ACCOUNT  (
		  ACCOUNTID VARCHAR(50) NOT NULL , 
		  OVERDRAFTPROTECTION FLOAT,
                  OVERDRAFTUSED FLOAT,
                  BALANCE FLOAT
                  )
                  IN rootdbs;
		 
----------------------------------------------------------------------
--DDL statements for primary key on table: POSTINGSSCHEMA.ACCOUNT
----------------------------------------------------------------------
ALTER TABLE POSTINGSSCHEMA.ACCOUNT 
     ADD CONSTRAINT PRIMARY KEY(ACCOUNTID);

---------------------------------------------------
--DDL statements  for table: "POSTINGSSCHEMA.OVERDRAFTACCOUNTPOSTING"
---------------------------------------------------
CREATE TABLE  POSTINGSSCHEMA.OVERDRAFTACCOUNTPOSTING  (
		  JOBID VARCHAR(130) NOT NULL , 
		  STEPID VARCHAR(250) NOT NULL
                  )
                  IN rootdbs;
		 
-----------------------------------------------------------------------------
--DDL statements for primary key on table: POSTINGSSCHEMA.OVERDRAFTACCOUNTPOSTING
----------------------------------------------------------------------------
ALTER TABLE POSTINGSSCHEMA.OVERDRAFTACCOUNTPOSTING 
     ADD CONSTRAINT PRIMARY KEY(JOBID,STEPID);


---------------------------------------------------
--DDL statements  for table: "POSTINGSSCHEMA.POSTINGACCOUNTDATA"
---------------------------------------------------
CREATE TABLE  POSTINGSSCHEMA.POSTINGACCOUNTDATA (
		  JOBID VARCHAR(130) NOT NULL , 
		  STEPID VARCHAR(250) NOT NULL
                  )
                  IN rootdbs;
		 
------------------------------------------------------------------------
--DDL statements for primary key on table: POSTINGSSCHEMA.POSTINGACCOUNTDATA
------------------------------------------------------------------------
ALTER TABLE POSTINGSSCHEMA.POSTINGACCOUNTDATA 
     ADD CONSTRAINT PRIMARY KEY(JOBID,STEPID);



---------------------------------------------------
--DDL statements  for table: "POSTINGSSCHEMA.DATACREATIONBEAN"
---------------------------------------------------
CREATE TABLE  POSTINGSSCHEMA.DATACREATIONBEAN  (
		  JOBID VARCHAR(130) NOT NULL , 
		  STEPID VARCHAR(250) NOT NULL
                  )
                  IN rootdbs;
		 
----------------------------------------------------------------------
--DDL statements for primary key on table: POSTINGSSCHEMA.DATACREATIONBEAN
----------------------------------------------------------------------
ALTER TABLE POSTINGSSCHEMA.DATACREATIONBEAN
     ADD CONSTRAINT PRIMARY KEY(JOBID,STEPID);


COMMIT WORK;






