-- Scriptfile to create a Cloudscape database for Long Running Scheduler. This script
-- can be modified if needed to change the name of database or name of the Schema used. Default
-- database name is LRSCHED and default schema name is LRSSCHEMA.
-- The script will produce the long running scheduler cloudscape database in the directory 
-- from which it is invoked.
-- Process This script in the ij command line processor.  
-- Example:  
-- java -Djava.ext.dirs=C:/WebSPhere/AppServer/cloudscape/lib -Dij.protocol=jdbc:db2j: com.ibm.db2j.tools.ij CreateLRSCHEDTablesCloudscape.ddl

CONNECT 'jdbc:db2j:LRSCHED;create=true';



CREATE SCHEMA LRSSCHEMA;

------------------------------------------------

-- DDL Statements for table "LRSSCHEMA"."GLOBALJOBIDASSIGNMENT"

------------------------------------------------

 

 CREATE TABLE "LRSSCHEMA"."GLOBALJOBIDASSIGNMENT"  (

		  "JOBSCHEDULERNAME" VARCHAR(250) NOT NULL , 

		  "JOBNUMBER" INTEGER NOT NULL )   

		   ; 



-- DDL Statements for primary key on Table "LRSSCHEMA"."GLOBALJOBIDASSIGNMENT"



ALTER TABLE "LRSSCHEMA"."GLOBALJOBIDASSIGNMENT" 

	ADD CONSTRAINT "PK_GLOBALJOBIDASS2" PRIMARY KEY

		("JOBSCHEDULERNAME",

		 "JOBNUMBER");


CREATE INDEX "LRSSCHEMA"."JOBNUM_INDX" ON "LRSSCHEMA"."GLOBALJOBIDASSIGNMENT" 

		("JOBNUMBER" ASC);







------------------------------------------------

-- DDL Statements for table "LRSSCHEMA"."LOGMESSAGES"

------------------------------------------------

 

 CREATE TABLE "LRSSCHEMA"."LOGMESSAGES"  (

		  "JOBID" VARCHAR(250) NOT NULL , 

		  "MSGSEQ" INTEGER NOT NULL , 

		  "MSGTXT" VARCHAR(250) )   

		   ; 



-- DDL Statements for primary key on Table "LRSSCHEMA"."LOGMESSAGES"



ALTER TABLE "LRSSCHEMA"."LOGMESSAGES" 

	ADD CONSTRAINT "PK_LOGMESSAGES" PRIMARY KEY

		("JOBID",

		 "MSGSEQ");







------------------------------------------------

-- DDL Statements for table "LRSSCHEMA"."JOBSTATUS"

------------------------------------------------

 

 CREATE TABLE "LRSSCHEMA"."JOBSTATUS"  (

		  "JOBID" VARCHAR(250) NOT NULL , 

		  "STATUS" INTEGER NOT NULL , 

		  "RC" INTEGER NOT NULL , 

		  "UPDATECNT" INTEGER NOT NULL , 

		  "LASTUPDATE" VARCHAR(250) , 

		  "SUSPENDEDUNTIL" VARCHAR(250) , 

		  "SCHEDULEROWNS" SMALLINT NOT NULL , 

		  "OWNINGBJEE" VARCHAR(250) , 

		  "TYPE" VARCHAR(16),

		  "SUBMITTER" VARCHAR(32),

		  "NODE" VARCHAR(250),

		  "APPSERVER" VARCHAR(250),

		  "STATUSTXT" VARCHAR(250),
		  
		  "STARTTIME" VARCHAR(250),
		  
		  "REQUESTID" VARCHAR(250) )   

		   ; 



-- DDL Statements for primary key on Table "LRSSCHEMA"."JOBSTATUS"



ALTER TABLE "LRSSCHEMA"."JOBSTATUS" 

	ADD CONSTRAINT "PK_JOBSTATUS" PRIMARY KEY

		("JOBID");







------------------------------------------------

-- DDL Statements for table "LRSSCHEMA"."SCHEDULERCOUNTER"

------------------------------------------------

 

 CREATE TABLE "LRSSCHEMA"."SCHEDULERCOUNTER"  (

		  "CNTNAME" VARCHAR(250) NOT NULL , 

		  "CNT" INTEGER NOT NULL )   

		   ; 



-- DDL Statements for primary key on Table "LRSSCHEMA"."SCHEDULERCOUNTER"



ALTER TABLE "LRSSCHEMA"."SCHEDULERCOUNTER" 

	ADD CONSTRAINT "PK_SCHEDULERCOUNT3" PRIMARY KEY

		("CNTNAME");







------------------------------------------------

-- DDL Statements for table "LRSSCHEMA"."XJCLREPOSITORY"

------------------------------------------------

 

 CREATE TABLE "LRSSCHEMA"."XJCLREPOSITORY"  (

		  "JOBID" VARCHAR(250) NOT NULL , 

		  "SEQ" INTEGER NOT NULL , 

		  "TXT" VARCHAR(250) )   

		   ; 



-- DDL Statements for primary key on Table "LRSSCHEMA"."XJCLREPOSITORY"



ALTER TABLE "LRSSCHEMA"."XJCLREPOSITORY" 

	ADD CONSTRAINT "PK_XJCLREPOSITORY" PRIMARY KEY

		("JOBID",

		 "SEQ");







------------------------------------------------

-- DDL Statements for table "LRSSCHEMA"."JOBREPOSITORY"

------------------------------------------------

 

 CREATE TABLE "LRSSCHEMA"."JOBREPOSITORY"  (

		  "JOBNAME" VARCHAR(250) NOT NULL , 

		  "SEQ" INTEGER NOT NULL , 

		  "TXT" VARCHAR(250) )   

		 ; 



-- DDL Statements for primary key on Table "LRSSCHEMA"."JOBREPOSITORY"



ALTER TABLE "LRSSCHEMA"."JOBREPOSITORY" 

	ADD CONSTRAINT "PK_JOBREPOSITORY" PRIMARY KEY

		("JOBNAME",
                
		 "SEQ");


------------------------------------------------

-- DDL Statements for table "LRSSCHEMA"."RECURRINGREQUEST"

------------------------------------------------

 

 CREATE TABLE "LRSSCHEMA"."RECURRINGREQUEST"  (

		  "REQUESTID" VARCHAR(250) NOT NULL , 

		  "JOBNAME" VARCHAR(250) NOT NULL , 

		  "STARTTIME" VARCHAR(250) NOT NULL , 

		  "INTERVAL" VARCHAR(250) NOT NULL ,
		   
		  "SUBMITTER" VARCHAR(32),

		  "STATUS" INTEGER, 

		  "FIELD1" INTEGER, 

		  "FIELD2" VARCHAR(250) )   

		 ; 



-- DDL Statements for primary key on Table "LRSSCHEMA"."RECURRINGREQUEST"



ALTER TABLE "LRSSCHEMA"."RECURRINGREQUEST" 

	ADD CONSTRAINT "PK_RECURRINGREQ" PRIMARY KEY

		("REQUESTID");












COMMIT WORK;



DISCONNECT;




