-- This script creates Long Running Scheduler tables on an oracle db.
--
-- 1.Process this script using SQL*Plus
-- 2. Replace all occurrances of @LRSCHED_TABLESPACE@ with a valid tablespace that was 
--    created by the CreateLRSCHEDTablespaceOracle.ddl script.
-- Example: 
--  o  sqlplus username/password@LRSCHED @CreateLRSCHEDTablesOracle.ddl
--  o  or, at the sqlplus prompt, enter
--     SQL> @CreateLRSCHEDTablesOracle.ddl


------------------------------------------------

-- DDL Statements for table "GLOBALJOBIDASSIGNMENT"

------------------------------------------------

 

 CREATE TABLE "GLOBALJOBIDASSIGNMENT"  (
		  "JOBSCHEDULERNAME" VARCHAR(250) NOT NULL , 
		  "JOBNUMBER" INTEGER NOT NULL )   
		 TABLESPACE @LRSCHED_TABLESPACE@ ; 



-- DDL Statements for primary key on Table "GLOBALJOBIDASSIGNMENT"



ALTER TABLE "GLOBALJOBIDASSIGNMENT" 
	ADD CONSTRAINT "PK_GLOBALJOBIDASS2" PRIMARY KEY
		("JOBSCHEDULERNAME",
		 "JOBNUMBER");


CREATE INDEX "JOBNUM_INDX" ON "GLOBALJOBIDASSIGNMENT" 
		("JOBNUMBER" ASC)
		PCTFREE 10;






------------------------------------------------

-- DDL Statements for table "LOGMESSAGES"

------------------------------------------------

 

 CREATE TABLE "LOGMESSAGES"  (
		  "JOBID" VARCHAR(250) NOT NULL , 
		  "MSGSEQ" INTEGER NOT NULL , 
		  "MSGTXT" VARCHAR(250) )   
		 TABLESPACE @LRSCHED_TABLESPACE@ ; 



-- DDL Statements for primary key on Table "LOGMESSAGES"



ALTER TABLE "LOGMESSAGES" 
	ADD CONSTRAINT "PK_LOGMESSAGES" PRIMARY KEY
		("JOBID",
		 "MSGSEQ");







------------------------------------------------

-- DDL Statements for table "JOBSTATUS"

------------------------------------------------

 

 CREATE TABLE "JOBSTATUS"  (
		  "JOBID" VARCHAR(250) NOT NULL , 
		  "STATUS" INTEGER NOT NULL , 
		  "RC" INTEGER NOT NULL , 
		  "UPDATECNT" INTEGER NOT NULL , 
		  "LASTUPDATE" VARCHAR(250) , 
		  "SUSPENDEDUNTIL" VARCHAR(250) , 
		  "SCHEDULEROWNS" SMALLINT NOT NULL , 
		  "OWNINGBJEE" VARCHAR(250) , 
		  "TYPE" VARCHAR(16),
		  "SUBMITTER" VARCHAR(32),
		  "NODE" VARCHAR(250),
		  "APPSERVER" VARCHAR(250),
		  "STATUSTXT" VARCHAR(250),
		  "STARTTIME" VARCHAR(250),
		  "REQUESTID" VARCHAR(250) )   
		 TABLESPACE @LRSCHED_TABLESPACE@ ; 



-- DDL Statements for primary key on Table "JOBSTATUS"



ALTER TABLE "JOBSTATUS" 
	ADD CONSTRAINT "PK_JOBSTATUS" PRIMARY KEY
		("JOBID");







------------------------------------------------

-- DDL Statements for table "SCHEDULERCOUNTER"

------------------------------------------------

 

 CREATE TABLE "SCHEDULERCOUNTER"  (
		  "CNTNAME" VARCHAR(250) NOT NULL , 
		  "CNT" INTEGER NOT NULL )   
		 TABLESPACE @LRSCHED_TABLESPACE@ ; 



-- DDL Statements for primary key on Table "SCHEDULERCOUNTER"



ALTER TABLE "SCHEDULERCOUNTER" 
	ADD CONSTRAINT "PK_SCHEDULERCOUNT3" PRIMARY KEY
		("CNTNAME");







------------------------------------------------

-- DDL Statements for table "XJCLREPOSITORY"

------------------------------------------------

 

 CREATE TABLE "XJCLREPOSITORY"  (
		  "JOBID" VARCHAR(250) NOT NULL , 
		  "SEQ" INTEGER NOT NULL , 
		  "TXT" VARCHAR(250) )   
		 TABLESPACE @LRSCHED_TABLESPACE@ ; 



-- DDL Statements for primary key on Table "XJCLREPOSITORY"



ALTER TABLE "XJCLREPOSITORY" 
	ADD CONSTRAINT "PK_XJCLREPOSITORY" PRIMARY KEY
		("JOBID",
		 "SEQ");






------------------------------------------------

-- DDL Statements for table "JOBREPOSITORY"

------------------------------------------------

 

 CREATE TABLE "JOBREPOSITORY"  (
		  "JOBNAME" VARCHAR(250) NOT NULL , 
		  "SEQ" INTEGER NOT NULL , 
		  "TXT" VARCHAR(250) )   
		 TABLESPACE @LRSCHED_TABLESPACE@ ; 



-- DDL Statements for primary key on Table "JOBREPOSITORY"



ALTER TABLE "JOBREPOSITORY" 
	ADD CONSTRAINT "PK_JOBREPOSITORY" PRIMARY KEY
		("JOBNAME",
		 "SEQ");

		 
		 
		 
		 
------------------------------------------------

-- DDL Statements for table "RECURRINGREQUEST"

------------------------------------------------

 

 CREATE TABLE "RECURRINGREQUEST"  (
		  "REQUESTID" VARCHAR(250) NOT NULL , 
		  "JOBNAME" VARCHAR(250) NOT NULL , 
		  "STARTTIME" VARCHAR(250) NOT NULL , 
		  "INTERVAL" VARCHAR(250) NOT NULL ,
		  "SUBMITTER" VARCHAR(32),
		  "STATUS" INTEGER, 
		  "FIELD1" INTEGER, 
		  "FIELD2" VARCHAR(250) )   
		  TABLESPACE @LRSCHED_TABLESPACE@ ; 



-- DDL Statements for primary key on Table "RECURRINGREQUEST"



ALTER TABLE "RECURRINGREQUEST" 
	ADD CONSTRAINT "PK_RECURRINGREQ" PRIMARY KEY
		("REQUESTID");

		 