-- This script creates Long Running Scheduler tables on a db2 instance.
-- The default name of the database is LRSCHED, default schema name is
-- LRSSCHEMA and default tablesapce is USERSPACE1. All these defaults
-- can be replaced with different names if needed.
-- The following commands can be issue from DB2 command line processor
-- to run this script:
--             db2 -tf MigrateLRSCHEDTablesDB2.ddl



 
CONNECT TO LRSCHED;

------------------------------------------------

-- DDL Statements for table "LRSSCHEMA"."JOBSTATUS"

------------------------------------------------


ALTER TABLE "LRSSCHEMA"."JOBSTATUS" 

	ADD "STARTTIME" VARCHAR(250)
	
	ADD "REQUESTID" VARCHAR(250);




------------------------------------------------

-- DDL Statements for table "LRSSCHEMA"."RECURRINGREQUEST"

------------------------------------------------

 

 CREATE TABLE "LRSSCHEMA"."RECURRINGREQUEST"  (

		  "REQUESTID" VARCHAR(250) NOT NULL , 

		  "JOBNAME" VARCHAR(250) NOT NULL , 

		  "STARTTIME" VARCHAR(250) NOT NULL , 

		  "INTERVAL" VARCHAR(250) NOT NULL ,
		   
		  "SUBMITTER" VARCHAR(32),

		  "STATUS" INTEGER, 

		  "FIELD1" INTEGER, 

		  "FIELD2" VARCHAR(250) )   

		 IN "USERSPACE1" ; 



-- DDL Statements for primary key on Table "LRSSCHEMA"."RECURRINGREQUEST"



ALTER TABLE "LRSSCHEMA"."RECURRINGREQUEST" 

	ADD CONSTRAINT "PK_RECURRINGREQ" PRIMARY KEY

		("REQUESTID");



COMMIT WORK;



CONNECT RESET;



TERMINATE;

-- Specified SCHEMA is: LRSSCHEMA

-- Creating DDL for table(s)



-- Schema name is ignored for the Federated Section

-- Binding package automatically ... 

-- Bind is successful

-- Binding package automatically ... 

-- Bind is successful

;