-- This script creates Long Running Scheduler tables on an oracle db.
--
-- 1.Process this script using SQL*Plus
-- 2. Replace all occurrances of @LRSCHED_TABLESPACE@ with a valid tablespace that was 
--    created by the CreateLRSCHEDTablespaceOracle.ddl script.
-- Example: 
--  o  sqlplus username/password@LRSCHED @MigrateLRSCHEDTablesOracle.ddl
--  o  or, at the sqlplus prompt, enter
--     SQL> @MigrateLRSCHEDTablesOracle.ddl

------------------------------------------------

-- DDL Statements for table "JOBSTATUS"

------------------------------------------------


ALTER TABLE "JOBSTATUS" 
	ADD "STARTTIME" VARCHAR(250)
	ADD "REQUESTID" VARCHAR(250);
	


	
------------------------------------------------

-- DDL Statements for table "RECURRINGREQUEST"

------------------------------------------------

 

 CREATE TABLE "RECURRINGREQUEST"  (
		  "REQUESTID" VARCHAR(250) NOT NULL , 
		  "JOBNAME" VARCHAR(250) NOT NULL , 
		  "STARTTIME" VARCHAR(250) NOT NULL , 
		  "INTERVAL" VARCHAR(250) NOT NULL ,
		  "SUBMITTER" VARCHAR(32),
		  "STATUS" INTEGER, 
		  "FIELD1" INTEGER, 
		  "FIELD2" VARCHAR(250) )   
		  TABLESPACE @LRSCHED_TABLESPACE@ ; 



-- DDL Statements for primary key on Table "RECURRINGREQUEST"



ALTER TABLE "RECURRINGREQUEST" 
	ADD CONSTRAINT "PK_RECURRINGREQ" PRIMARY KEY
		("REQUESTID");



		
