// IBM Confidential OCO Source Material
// 5724-J34 (C) COPYRIGHT International Business Machines Corp. 2004, 2005
// The source code for this program is not published or otherwise divested
// of its trade secrets, irrespective of what has been deposited with the
// U.S. Copyright Office.

//aptree.js
/////////////////////////////////////////////////////////////
// Global Variables
/////////////////////////////////////////////////////////////

var tree_root = null; // node to the root of the tree
var maxNodes = 0; // total count of the nodes
var browser = 0; // browser type
var nodeIndex = new Array(); // index of all the nodes in the tree
var nodeIDIndex = new Array();
var totalWidth = 0; // total width of the tree
var abort = null; // Abort Url if browser doesn't support dhtml
var selected = null; // The currently selected item
var expandDepth = -1; // Depth to which we should initially expand;
// expand the entire tree by default
var showselect = 0; // = 1 if we are to change icon on select
var selectedicon = "select.gif";
var selectednode = null;

var treeDisplayed = false;

/*** The following were added my M Etgen  ***/

var blankIcon = "/ibm/console/images/blank20.gif";
var openFolder = "/ibm/console/images/open_folder.gif";
var closedFolder = "/ibm/console/images/closed_folder.gif";
var plusIcon = "";
var minusIcon = "";
var targetFrame = "";
var inTable = "";
var keepState = "";
var showHealth = "";
var showExpanders = "";
var imagePath = "";
var helpPath = "";

/**
 *   If the tree has a form element above, ns4 needs to adjust the tree up 30 px or so *
 */
var ns4InFormAdjustment = 10;

/**
 *   Whether to let the text wrap or not - value should be <NOBR> and </NOBR> for wrap off *
 */
var beginBreak = "<NOBR>";
var endBreak = "</NOBR>";

var provIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/provIcon.gif";
var onePixIcon = "/ibm/console/images/onepix.gif";
var deprovIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/deprovIcon.gif";


/////////////////////////////////////////////////////////////
// Define a tree node
//
// Inputs:
//   icon - name of the icon eg. /file/btn.gif
//   content - node or foler content (can be HTML text)
//   link - link for the name and icon
//   parent - parent node
//   id - id assigned to the node
/////////////////////////////////////////////////////////////
function TreeNode(icon, icon_alt, content, link, parent, id, level, selectable, htmlCreator, type)
{
	// Class Variables
	this.icon_alt = icon_alt; //alternate text to be displayed for icon
	this.type = type;
	this.icon = icon; // Content Icon
	this.instanceIcon; // Instance Icon (used with sick server icons)
	this.link = link; // Content Link
	this.level = level; // Nodes Level wrt root node
	this.content = content; // Content to be displayed
	this.parent = parent; // Parent TreeNode
	this.children = new Array(); // Children of the current TreeNode
	this.childCount = 0; // Number of children of this TreeNode
	this.id = id; // TreeNode Id number
	this.layer = null; // Layer refering to the content displayed
	this.expanded = false;
	
	//if (top.savedRTState == null)
	//{
	//	if(level < 3) // Are the children visible?  we only want to expand the first 2 levels to begin (levels 1 and 2)
	//		this.expanded = true;
	//	else 
	//		this.expanded = false;
	//}
		
	
	this.PSrc = null; // Plus icon source url
	this.MSrc = null; // Minus icon source url
	this.button = null; // Browser image object to the PM button
	this.selectable = selectable;
	this.toString = 
	function ()
	{
		return this.id;
	};
	//METHODS:	
	if(htmlCreator)
		this.getInnerHtml = htmlCreator;
	this.setPadding = setPadding;
	this.imagePath = imagePath;
	this.blankIcon = blankIcon;
	this.showExpanders = showExpanders;
	this.openFolder = openFolder;
	this.closedFolder = closedFolder;
	this.plusIcon = plusIcon;
	this.minusIcon = minusIcon;
	this.targetFrame = targetFrame;
	this.showHealth = showHealth;
	
	if(imagePath != "")
	{
		this.icon = imagePath + this.icon;
		this.blankIcon = imagePath + this.blankIcon;
		this.plusIcon = imagePath + this.plusIcon;
		this.minusIcon = imagePath + this.minusIcon;
		this.openFolder = imagePath + this.openFolder;
		this.closedFolder = imagePath + this.closedFolder;
	}
	
	var tempicon = icon;
	var temploc = document.location.href;
	
	// Class Methods
	this.displayTree = displayTree;
	
}



/////////////////////////////////////////////////////////////
// initalize()
//   Display the inital state of the tree.
//
// Inputs:
//   None.
// Output:
//   Tree is displayed in the browser.
// Notes:
//   The tree has already been built by the setTreeRoot and
//   addTreeNode methods.
/////////////////////////////////////////////////////////////
function initialize()
{
	
	var node = tree_root;
	
	// quickly return to prevent error messages being displayed.
	if(node == null)
	return;
	
	// set the document node to the tree root
	document.node = tree_root;
	
}


/////////////////////////////////////////////////////////////
// displayTree()
//   display the tree built in memory
//
// Inputs:
//	 parent - the <DIV> into which this tree will be displayed (this is the same for all recursive calls - just pass "parent")
//   node - the node to show
//   spacer - html text spacer
//   lastNode - boolean flag inidcating last child
//   root - is this node the root node.
// Outputs:
//   The tree is displayed to the browser's window
/////////////////////////////////////////////////////////////
function displayTree(purpose, parent, node, spacer, lastnode, root, level)
{
	var theDiv = document.createElement("div");
	theDiv.id = "DIV_" + node.id;
	
	theDiv.className = "indent" + node.level;
	if(node.childCount > 0 || !node.parent)
	theDiv.className += "kids";
	
	if(node.parent == null || node.parent.expanded)
	theDiv.style.display = "block";
	else 
	theDiv.style.display = "none";
	
	if(node.getInnerHtml)
	theDiv.innerHTML = node.getInnerHtml(purpose);
	else 
	theDiv.innerHTML = node.content;
	
	node.setPadding(theDiv);
	
	parent.appendChild(theDiv);
	node.layer = theDiv;
	
	// Loop around all the children and add them
	for(var i = 0; i < node.childCount; i++)
	{
		var lstnode = false;
		if(i == (node.childCount-1))
		lstnode = true;
		node.children[i].displayTree(purpose, parent, node.children[i], spacer, lstnode, false, level+1);
	}
	
}

function setPadding(theDiv)
{
	var padding = (19 * this.level) - 16;
	if (padding < 0)
		padding = 0;
	theDiv.style.paddingLeft = padding;
}

function getExpanderIcon(node)
{
	if(node.showExpanders)
	{
		node.PSrc = node.plusIcon;
		node.MSrc = node.minusIcon;
	}
	else 
	{
		node.PSrc = node.blankIcon;
		node.MSrc = node.blankIcon;
	}
	var isBlank=false;
	if(node.childCount < 1 || this.parent == null){
		useSrc = BLANK_EXPANDER_ICON;
		isBlank=true;
	} else if(node.expanded)
		useSrc = node.MSrc;
	else 
		useSrc = node.PSrc;
	
	var expandCompress;
	if (!isBlank)
		expandCompress = "expandCompressNode('" + node.id + "');return false";
	else 
		expandCompress = "return false;";
		
	var theLink = '<a href="javascript:' + expandCompress + '" onclick="' + expandCompress + '">' + 	'<img src="' + useSrc + '" id="PM' + node.id + '" align="texttop" border="0" alt=""></a>';
	return theLink;
}

function getIcon(node)
{
	if(!node.icon)
		return "";
	if (!node.icon_alt)
		node.icon_alt = "";

    sickInd = "";
    sickStyle = "";
    sickStyleMask = "";
    if ((node.icon.indexOf("fatal")>-1) || (node.icon.indexOf("critical")>-1) || (node.icon.indexOf("severe")>-1) || (node.icon.indexOf("warning")>-1)) 
    {
        sickInd = "_SICK";
        
        if (node.type == "NodeGroup") 
        {
           sickStyleMask = "filter:alpha(opacity=33);-moz-opacity:.33;opacity:.33;";
        } 
        else if (node.type == "Node") 
        {
            sickStyleMask = "filter:alpha(opacity=66);-moz-opacity:.66;opacity:.66;";
        }

        if ((node.expanded) && (node.type != "DeploymentTargetInstance"))
        {
           if ((node.type == "NodeGroup") && (node.id.indexOf("NodeGroup_") > -1))  //for the NodeGroup element
           {
              for (var a=0; a < node.children.length;a++)
              {
                 if (node.children[a].id.indexOf("Nodes_NodeGroup_") > -1)
                 {
                    if (node.children[a].expanded == true)
                       sickStyle = "display:none;position:absolute;left:1em;margin-top:-0.25em;"+sickStyleMask;
                    else
                       sickStyle = "display:inline;position:absolute;left:1em;margin-top:-0.25em;"+sickStyleMask;
                 }
              }
           }
           else
           {
        	     sickStyle = "display:none;position:absolute;left:1em;margin-top:-0.25em;"+sickStyleMask;
           }
        } 
        else 
        {
            sickStyle = "display:inline;position:absolute;left:1em;margin-top:-0.25em;"+sickStyleMask;
        }
    }
    colorChanger = "";
    if (sickInd == "_SICK") {
        colorChanger = 'onload="if (this.style.display != \'none\') parentNode.parentNode.style.backgroundColor=\'#f6f6f6\'"';
    }
	
	var html = '<img '+colorChanger+' style="margin-right:5px;'+sickStyle+'" src="' + node.icon + '" name="icon' + node.id + '" id="ICON_' + node.id + sickInd +'" border="0" title="" align="texttop">';
	
	if (node.type == ELEMENT_NODE) //Only do this part if we are looking at a NODE element
	{
		if (node.children)
		{
			for(var x = 0; x < node.children.length; x++)
			{
				//If a server in this node is sick, pop a secondary icon as well
				if ((node.children[x].dTHealthSickInd == SICK_SERVER) && (node.icon != nodeIcon) && (node.icon != maintModeIcon) && (node.icon != gridNodeIcon))
				{
					var _icon;
					if (MAINTENANCE_MODE_ON == node.maintMode ) 
						_icon = {url:maintModeIcon, alt:MAINTMODE_ICON_LABEL};
					else
						_icon = {url:nodeIcon, alt:NODE_ICON_LABEL};
		
					var sec_html = '<img style="margin-right:5px;" src="' + _icon.url + '" name="2nd_icon' + node.id + '" id="2nd_ICON_' + node.id + '" border="0" title="" alt="'+ _icon.alt + '" align="texttop">';
					
					html = html + sec_html;
				}
			}
		}
	}
	
	if ((node.type == "DeploymentTargetInstance") && (sickInd == "_SICK"))
		node.instanceIcon = "/ibm/console/com.ibm.ws.console.xdruntime/images/jasmInstanceIcon_" + node.state + ".gif";

	if (node.instanceIcon && node.instanceIcon != "") //if the node is showing a sick server icon, show the instance icon when appropriate
	{
		html = html + '<img style="margin-right:5px;" src="' + node.instanceIcon + '" name="Instance_icon' + node.id + '" id="Instance_ICON_' + node.id + '" border="0" align="texttop">';
	}

	document.getElementById("progress").style.display = "block";
	document.getElementById("progress").style.display = "none";

	return html;
}

function getIconAndContent(node, purpose)
{
   var eventHandlerText;
	var icon = getIcon(node);
	
   if(!node.content && (icon == ""))
	   return "";

	if (!purpose)
		purpose = DEFAULT_PURPOSE;
	
   //if it's not a DeploymentTarget or Specialty Server, setup the Hover...if applicable
   if ((node.type != ELEMENT_DEPLOYMENTTARGET) && (node.type != ELEMENT_SPECIALTYSERVER))
   {
      eventHandlerText = ' onMouseOver="displayPopup(\'' + node.id + '\', event, \'' + node.type + '\', \'' + purpose + '\');" onMouseOut="hidePopup();" onFocus="displayPopupOnFocus(\'' + node.id + '\', this, \'' + node.type + '\', \'' + purpose + '\');" onBlur="hidePopup();"';
   }
   else if ((node.type == ELEMENT_SPECIALTYSERVER) && (node.SSType == ELEMENT_DBSERVER))
   {
      eventHandlerText = ' onMouseOver="displayPopup(\'' + node.id + '\', event, \'' + node.type + '\', \'' + purpose + '\');" onMouseOut="hidePopup();" onFocus="displayPopupOnFocus(\'' + node.id + '\', this, \'' + node.type + '\', \'' + purpose + '\');" onBlur="hidePopup();"';   
   }
	
	var menuable = false;
	if (isMenuAble(node))
   {
		eventHandlerText += ' onclick="createMenuOnEvent(event, \'' + node.id + '\');return false;" ';		
		menuable = true;
	}

	var html;
	var bold = "";
	var unbold = "";
	if (!node.parent){
		bold = "<b>";
		unbold ="</b>";
	}

	if(node.selectable)
		html = '<a href="' + (node.link) + '" ' + eventHandlerText + ' target="' + node.targetFrame + '">' + icon + '<span>' + bold + node.content + unbold+'</span></a>';
	else if(node.childCount > 0 && node.icon == null && node.parent != null) //root level node doesn't get expand/compress - this is for special nodes, other than the parent
	{
		//var expandCompress = "javascript:void();";
		var expandCompress = "expandCompressNode('" + node.id + "');";
		html = '<a href="javascript:' + expandCompress + '" ' + ' " style="text-decoration:none; color:black;" >' + icon +  '<span> ' + node.content + '</span>';
	} else if ( menuable){
		// XD60_M1_L.RT.4 - display node name for singleton app. server
		// under deployment target and singleton generic server under
		// specialty server on the nodegroup prespective.
		if ((node.type == ELEMENT_DEPLOYMENTTARGET &&  node.nodeName) ||
	  	   (node.type == ELEMENT_SPECIALTYSERVER
		    && node.parent.content == GENERICSERVERS && node.nodeName) )
			html = '<a href="javascript:void 0;" ' + eventHandlerText + ">" + icon + '<span style="color:blue; cursor:pointer; text-decoration:underline;">' + node.content + " (" + node.nodeName + ")</span></a>";
		else
		{
			html = '<a href="javascript:void 0;" ' + eventHandlerText + ">" + icon + '<span style="color:blue; cursor:pointer; text-decoration:underline;">' + node.content + "</span></a>";
		}
	} else {
		html = '<a href="javascript:void 0;" style="text-decoration:none; color:black;" ' + eventHandlerText + ">" + icon + '<span>' + node.content + '</span></a>';
	}


	return html;
}


/////////////////////////////////////////////////////////////
// addItem()
//   Add an item to the tree
// Inputs:
//   parent - parent node
//   icon - name of the icon eg. ./file/btn.gif
//   content - node or folder content (can be HTML text)
//   link - link for the name and icon
// Output:
//   The tree node that has been created.
/////////////////////////////////////////////////////////////
function addItem(purpose, parent, icon, icon_alt, content, link, id, htmlGenerator, type)
{
	var selectable = true;
	
	//if(parent == null)
	//{ACTUALLY, THIS MEANS IT IS THE TREE_ROOT, NOT THE TREE_ROOT'S CHILD.
		// assume that a null parent infers adding the root node
		//parent = tree_root;
	//}
	
	if(link == "")
	{
		selectable = false;
	}
	
	if(helpPath != "")
	{
		link = helpPath + link;
	}
	
	maxNodes++;
	var tempNode = new TreeNode(icon, icon_alt, content, link, parent, id, parent.level + 1, selectable, htmlGenerator, type);
	tempNode.browser = browser;
	
	if (nodeIndex[id]){
        var node = nodeIndex[id];
        rootDiv.removeChild(node.layer);
        delete nodeIndex[id]; //remove this node from the nodeIndex
        removeFromParent(node);
   }
	nodeIndex[id] = tempNode;
	nodeIDIndex[maxNodes] = id;
		
	parent.children[parent.childCount++] = tempNode;
	
	if(treeDisplayed)
		addItemToExistingTree(tempNode, purpose);
	
	return tempNode;
}

//can't add a new root this way...its parent would be null
function addItemToExistingTree(node, purpose)
{
	//tree was already displayed, so we have to make this update on the fly
	//find all the div tags in the mainContent div, walk through til we find this new tag's parent, and add the new div right after the parent
	
	var childDivs = rootDiv.getElementsByTagName("div");
	var parentIndex = -1;
	var parent = node.parent;
	var insertBefore = null;
	for(var x = 0; x < childDivs.length; x++)
	{
		if(childDivs[x].id == parent.layer.id)
		{
			parentIndex = x;
			break;
		}
	}
	
	if(parentIndex > -1)
	{
		//otherwise, didn't find the parent...don't add this node 
		var newDiv = document.createElement("div");
		newDiv.id = "DIV_" + node.id;

		if(parentIndex != (childDivs.length - 1))
		rootDiv.insertBefore(newDiv, childDivs[parentIndex + 1]);
		else 
		rootDiv.appendChild(newDiv);
		
		if(!parent.expanded)
		newDiv.style.display = "none";
		
		if(parent.childCount == 1)
		{
			//if it didn't have children before we added THIS node, we need to refresh to get the plus/minus
			parent.layer.innerHTML = parent.getInnerHtml(purpose);
		}
		node.layer = newDiv;
		newDiv.innerHTML = node.getInnerHtml(purpose);
		node.setPadding(newDiv);
	}
}



/////////////////////////////////////////////////////////////
// 
// addRoot()
//   Set the root of the tree to be constructed
// Inputs:
//   parent - parent node
//   icon - name of the icon eg. ./file/btn.gif
//   content - node or foler content (can be HTML text)
//   link - link for the name and icon
// Output:
//   The root tree node that has been created.
/////////////////////////////////////////////////////////////
function addRoot(icon, rootElem, purpose)
{
	var type = rootElem.getAttribute(ATTR_TYPE);
	var content = rootElem.getAttribute(ATTR_NAME);
	var id = rootElem.getAttribute(ATTR_ID);
	var linkFunction = linkFunctions[type];
	var populatorFunction = populatorFunctions[type];
	var innerHTMLFunction = innerHTMLFunctions[type];
	
		
	// create a new node and set that as the root
	maxNodes++;
	var tempNode = new TreeNode(icon, "", content, link, null, id, 1, false, innerHTMLFunction);
	populatorFunction(rootElem, purpose, tempNode);
	
	if (menuCreators[type]){
		var link = "javascript:void 0;"; //linkFunction(tempNode);
		tempNode.link = link;
	} else
		link = "";
	
	tempNode.selectable = true;
	if(tempNode.link == "")
		tempNode.selectable = false;	
	
	tempNode.expanded = true;
	tree_root = tempNode;
	
	
	nodeIndex[id] = tempNode;
	return tempNode;
}

/////////////////////////////////////////////////////////////
// setAbort()
//   Set the url to abort to if browser dosen't support dhtml
//
// Inputs:
//   url - url to abort to if browser does not support Dynamic
//         html.
// Output:
//   golbal abort command is set
/////////////////////////////////////////////////////////////
function setAbort(url)
{
	abort = url;
}

function setImagePath(ip)
{
	imagePath = ip;
}

function setHelpPath(ip)
{
	helpPath = ip;
}

function setExpandDepth(iDepth)
{
	if(iDepth != null && iDepth >= 0)
	expandDepth = iDepth;
}

function setShowExpanders(sExpand)
{
	showExpanders = sExpand;
	
}


function setKeepState(ks)
{
	keepState = ks;
}


function setShowHealth(sh)
{
	showHealth = sh;
}


function setInTable(it)
{
	inTable = it;
}

function setTargetFrame(tf)
{
	targetFrame = tf;
}





/////////////////////////////////////////////////////////////
// expandChildren()
//   Expand the chlidren of the node by making the chlidren
//   nodes visable.
//
// Inputs:
//   node - the node to be expanded
//   depth - the absolute depth to which to expand (optional)
//           null:  expand leaves if previously expanded
//           < 0 :  forcefully expand entire tree
//           > 0 :  forcefully expand tree n levels from root
// Output:
//   None.
/////////////////////////////////////////////////////////////
function expandChildren(node, depth)
{
	var i;
	if(depth)
	depth--;
	
	node.expanded = true;
	
	if(keepState)
	{
		if(top.treeopen)
		top.treeopen[node.id] = 0;
	}
	
	
	for(i = 0; i < node.childCount; i++)
	{
		var cnode = node.children[i];
		document.getElementById('DIV_' + cnode.id).style.display = "block";
		
		// open up any previouly open children
		
		if(depth == null && cnode.expanded)
		expandChildren(cnode);
		else 
		{
			if(depth != null && depth != 0)
			expandChildren(cnode, depth);
		}
		
	}
	
	
}

function collectExpandedNodes()
{
	var expandedNodes = new Array();
	var i = 0;
	var a = 0;
	
	for (a = 1; a < nodeIDIndex.length; a++)
	{
		if (nodeIndex[nodeIDIndex[a]] != null)
		{
			if (nodeIndex[nodeIDIndex[a]].expanded)
			{
				expandedNodes[i] = nodeIDIndex[a];
				i++;
			}
		}
	}
	
	return expandedNodes; 
		
}



/////////////////////////////////////////////////////////////
// expandCompressNode()
//   Event Handler for the Plus-Minus buttons.  This procedure
//   will either expand a node or compress a node depending on
//   the current state of node.
//
// Inputs:
//   id - the id number of the node of which created the event
// Output:
//   None.
/////////////////////////////////////////////////////////////
function expandCompressNode(id)
{
	var node = nodeIndex[id];
	var button = document.getElementById("PM" + id);
	
	// determine the current state of the node
	
	var theimage = node.icon;
	var theimage2 = theimage.split("/");
	var theimage3 = theimage2[theimage2.length-1];
	var itsopen = node.openFolder.indexOf(theimage3, 0) + 1;
	var itsclosed = node.closedFolder.indexOf(theimage3, 0) + 1;
	//alert(itsopen+" Comparing "+node.openFolder+" to "+theimage3);
	
	if(!node.expanded)
	{
		button.src = node.MSrc;
		node.expanded = true;
		expandChildren(node);

        if ((document.getElementById('ICON_' + node.id + '_SICK') != null) &&
            (node.type != "DeploymentTargetInstance") &&
            (node.type != "NodeGroup"))    //for the NodeGroup element
        {
            document.getElementById('ICON_' + node.id + '_SICK').style.display = "none";
            document.getElementById('ICON_' + node.id + '_SICK').parentNode.parentNode.style.backgroundColor="#ffffff";            
        }
       	if ((document.getElementById('ICON_' + node.id + '_SICK') != null) &&
       	    (node.id.indexOf("Node_") > -1))  //for the Node element
       	{
            document.getElementById('ICON_' + node.id + '_SICK').style.display = "none";
            document.getElementById('ICON_' + node.id + '_SICK').parentNode.parentNode.style.backgroundColor="#ffffff";
		}            
         
       	if ((node.type == "NodeGroup") && 
       		(node.id.indexOf("NodeGroup_") > -1))  //for the NodeGroup element
        {
        	for (var a=0; a < node.children.length;a++)
        	{
        	  	if (node.children[a].id.indexOf("Nodes_NodeGroup_") > -1)
        	  	{
					if (node.children[a].expanded == true)
					{
						document.getElementById('ICON_' + node.id + '_SICK').style.display = "none";
			            document.getElementById('ICON_' + node.id + '_SICK').parentNode.parentNode.style.backgroundColor="#ffffff";
					}
				}
			}
		}

        if (node.id.indexOf("Nodes_NodeGroup_") > -1)
        {
        	if (document.getElementById('ICON_' + node.parent.id + '_SICK') != null)
        	{
            	document.getElementById('ICON_' + node.parent.id + '_SICK').style.display = "none";
	            document.getElementById('ICON_' + node.parent.id + '_SICK').parentNode.parentNode.style.backgroundColor="#ffffff";
            }
        }
 	}
	
	else 
	{
		button.src = node.PSrc;
		node.expanded = false;
		
		compressChildren(node);

        if (document.getElementById('ICON_' + node.id + '_SICK') != null) 
        {
            document.getElementById('ICON_' + node.id + '_SICK').style.display = "inline";
            document.getElementById('ICON_' + node.id + '_SICK').parentNode.parentNode.style.backgroundColor="#f6f6f6";            
        }
 
        if (node.id.indexOf("Nodes_NodeGroup_") > -1)
        {
         	if (document.getElementById('ICON_' + node.parent.id + '_SICK') != null)
        	{
            	document.getElementById('ICON_' + node.parent.id + '_SICK').style.display = "inline";
            	document.getElementById('ICON_' + node.parent.id + '_SICK').parentNode.parentNode.style.backgroundColor="#f6f6f6";            	
            }
        }        
	}

	document.getElementById("progress").style.display = "block";
	document.getElementById("progress").style.display = "none";

	/********
	 *  modified - added browser 3 *******
	 */
	if(!inTable)
	{
		if(node.browser == 1 || node.browser == 3)
		node.layout();
	}
}

/////////////////////////////////////////////////////////////
// compressChildren()
//   Compress the chlidren of the node by hiding its chlidren
//   nodes.
//
// Inputs:
//   node - the node to be compressed
// Output:
//   None.
/////////////////////////////////////////////////////////////
function compressChildren(node)
{
	var i;
	if(keepState)
	{
		if(top.treeopen)
		top.treeopen[node.id] = 1;
	}
	
	for(i = 0; i < node.childCount; i++)
	{
		var cnode = node.children[i];
		
		// Handle the different browser cases
		if(cnode.browser == 1)
		{
			document.layers['Item' + cnode.id].visibility = "hide";
		}
		
		/********
		 *  modified - added browser 3 *******
		 */
		document.getElementById("DIV_" + cnode.id).style.display = "none";
		
		if(cnode.childCount > 0)
		compressChildren(cnode);
	}
}


// browsers parse (and unescape) the href in the processing
// of an onclick.  By the time str gets to our callback,
// it is escaped again.  This ensures our callback gets a
// string with escaped backslashes.

function ebs(str)
{
	if(!str || str == null)
	return("");
	
	return(str.replace(/\\/g, "\\\\"));
}


function clk(targetFrame, sPath)
{
	targetFrame.location = sPath;
}
