#=======================================================================================================================================================
#(C) Copyright IBM Corp. 2004,2005 - All Rights Reserved.
#DISCLAIMER:
#The following source code is sample code created by IBM Corporation.
#This sample code is provided to you solely for the purpose of assisting you 
#in the  use of  the product. The code is provided 'AS IS', without warranty or 
#condition of any kind. IBM shall not be liable for any damages arising out of your
#use of the sample code, even if IBM has been advised of the possibility of
#such damages.
#=======================================================================================================================================================
import jarray
import sys
from com.ibm.ws.classify import ListFiles

#=======================================================================================================================================================
# Creates a WorkClass with user rules for Routing policy
#=======================================================================================================================================================
def createAppRoutingWorkClass(anApp):
   myDefaultAction="permit"
   routingWorkClass=""
   actionValue=""
   oldURI=""
   appShortName=anApp 
   print "the short appname = " + appShortName
   if (appShortName!=""):
       if (myDefaultAction != ""):
           dParts = myDefaultAction.split("?")
           actionType = dParts[0]
           actionValue = ""
           try:
              actionValue = dParts[1]
           except IndexError:
               if (actionValue == "" and actionType.startswith("permit")):
                   actionValue = appShortName
               else:
                   errorExit() 
           taskCmdArgs =  "[-appname "+ appShortName+" -wcname "+myWorkClassName+" -type "+myProtocolType+" -actiontype "+actionType+" -action "+actionValue+"]"
           print "Calling createSystemRoutingPolicyWorkClass with " +taskCmdArgs           
           routingWorkClass = AdminTask.createSystemRoutingPolicyWorkClass(taskCmdArgs)
           print "Created routing workclass = "+ routingWorkClass 
          
#=======================================================================================================================================================
# Creates a WorkClass with user rules for SLA policy
#=======================================================================================================================================================
def createAppSLAWorkClass(anApp):
   slaWorkClass=""
   appShortName=anApp
   oldURI=""
   protocolType = setProtocolForWorkClass()
   if (appShortName!=""):
       if (myTCName != ""):
           taskCmdArgs =  "[-appname "+ appShortName+" -wcname "+myWorkClassName+" -type "+myProtocolType+ " -tcname "+myTCName +" -appEditionName  "+appShortName+"]"
           print "Calling createSystemServicePolicyWorkClass with " +taskCmdArgs  
           slaWorkClass=AdminTask.createSystemServicePolicyWorkClass(taskCmdArgs)
           print "Created sla workclass = " + slaWorkClass	   

def findDeployment(applName):
   appNames=AdminConfig.list("Deployment").split("\n")
   for appName in appNames:
       appName=appName.rstrip()
       if (len(appName) > 0 ):
          if (appName.startswith(applName)):
             #print "matched application: " + appName
             return appName
   return ""

def setProtocolForWorkClass():
   if (myProtocolType == "SOAP"):
      protocolType = "SOAPWORKCLASS"
   elif (myProtocolType == "IIOP"):
      protocolType = "IIOPWORKCLASS"
   else:
      protocolType = "HTTPWORKCLASS"
   return protocolType 

def findAppRoutingWorkClass(aWCName):
   wcNames=AdminConfig.list("WorkClass").split("\n")
   for wcName in wcNames:
       wcName=wcName.rstrip()
       if (len(wcName) > 0 ):
          name=AdminConfig.showAttribute(wcName,"name")
          print "Routing WC name = " + name
          if (aWCName == name and wcName.find("deployments") == -1):
             appName=AdminConfig.showAttribute(wcName,"matchAction")
             if (appName.find(myAppName) > 0 ):
                return wcName
   return "" 
 
def findAppSLAWorkClass(aWCName):
   wcNames=AdminConfig.list("WorkClass").split("\n")
   for wcName in wcNames:
       wcName=wcName.rstrip()
       if (len(wcName) > 0 ):
          name=AdminConfig.showAttribute(wcName,"name")
          print " name --> " + name
          if (aWCName == name and wcName.find("deployments") > 0):
              appName=AdminConfig.showAttribute(wcName, "workClassModules").replace("[","").replace("]","").split(" ")[0]
              if (appName.find(myAppName) > 0):
                 print "matched app SLA workclass: " + appName
                 return wcName
   return "" 

def findWorkClass(aWCName,aPolicyType):
   wcNames=AdminConfig.list("WorkClass").split("\n")
   for wcName in wcNames:
       wcName=wcName.rstrip()
       if (len(wcName) > 0 and wcName.find(aPolicyType) > -1 and wcName.find(myOdrName) > 0):
          name=AdminConfig.showAttribute(wcName,"name")
          if (aWCName == name):
             print "matched WorkClass: " + name
             return wcName
   return ""  
  
def findTransactionClass(aTCName):
   tcNames=AdminConfig.list("TransactionClass").split("\n")
   for tcName in tcNames:
       tcName=tcName.rstrip()
       if (len(tcName) > 0 ):
          name=AdminConfig.showAttribute(tcName,"name")
          if (aTCName == name):
             print "matched Transaction Class: " + name
             return name
   return ""

def findSystemApplication(aAppName):
   wcNames=AdminConfig.list("WorkClass").split("\n")
   for wcName in wcNames:
       wcName=wcName.rstrip()
       if (len(wcName) > 0 ):
          name=AdminConfig.showAttribute(wcName,"name")
          if (name.startswith("Default_") and name.endswith("_WC")):
              appName=AdminConfig.showAttribute(wcName, "workClassModules").replace("[","").replace("]","").split(" ")[0]
              if (appName.find(aAppName) > 0):
                 print "system application " + aAppName + " exists"
                 return aAppName
   return "" 

def normalExit():
    java.lang.System.exit(0)
 
def errorExit():
    java.lang.System.exit(1)

#=======================================================================================================================================================
#
# Main defaultSystemAppsWorkClasses.py execution logic:
#
# 
#=======================================================================================================================================================
global myWorkClassName,myActionType,myAppName,myWebModule,myURIS,isAppWorkClasses,isListRule,isGetDefaultAction,myRule,mySysAppDir,myTCName
myProtocolType=""
myWorkClassName=""
myAppName=""
myWebModule=""
myAction=""
myWorkClassType=""
myURIS="*"
myEJBName=""
myRule=jarray.zeros(9,java.lang.String)
fileSeparator=java.lang.System.getProperty("file.separator")
mySysAppDir=java.lang.System.getProperty("was.install.root")+fileSeparator+"systemApps"
earList = ListFiles.listEarDirectory(mySysAppDir)
myWorkClassName = "Default_HTTP_WC"
myProtocolType = "HTTP"
myDefaultTC="Default_TC"
myTCName=findTransactionClass(myDefaultTC)
for ear in  earList:
		thisAppName=ListFiles.getName(ear)
		print "The .EAR file is " + thisAppName
		thisAppName=thisAppName.split(".")[0]
		createAppSLAWorkClass(thisAppName)
		createAppRoutingWorkClass(thisAppName)
print "Saving HTTP workclass changes ... "
AdminConfig.save()
myProtocolType="SOAP" 
myWorkClassName = "Default_SOAP_WC"       
for ear in  earList:
		thisAppName=ListFiles.getName(ear)
		print "The .EAR file is " + thisAppName
		thisAppName=thisAppName.split(".")[0]
		createAppSLAWorkClass(thisAppName)
		createAppRoutingWorkClass(thisAppName)
print "Saving SOAP workclass changes ... "
AdminConfig.save() 

